%define _requires_exceptions pear(default.php)

Name:		check-mk
Version:	1.2.4p5
Release:	2%{?dist}
Summary:	A new general purpose Nagios-plugin for retrieving data
Group:		Applications/Internet
License:	GPLv2 and GPLv3
URL:		http://mathias-kettner.de/check_mk
Source:		http://mathias-kettner.de/download/check_mk-%{version}.tar.gz
Requires:	nagios
%if 0%{?rhel}
Requires:	mod_python
%endif
Source1:	First-Installation.txt
Source2:	defaults
Source3:	defaults.py
Patch0:		01-Set-Legacy-Eval-True.patch
AutoReq:	0

# Do not provide from a documentation
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_docdir}/.*$

# Do not require any other shell than bash since that's the default Fedora / RHEL shell
%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
%global __requires_exclude %{?__requires_exclude}|^/bin/sh$
%global __requires_exclude %{?__requires_exclude}|^/usr/bin/ksh$
%endif

%if 0%{?rhel} == 6
%filter_from_requires /^\/bin\/sh/d
%filter_from_requires /^\/usr\/bin\/ksh/d
%filter_setup
%endif

%description
check-mk is a general purpose Nagios-plugin for retrieving data. It adopts a
new approach for collecting data from operating systems and network components.
It obsoletes NRPE, check_by_ssh, NSClient, and check_snmp and it has many
benefits, the most important are a significant reduction of CPU usage on
the Nagios host and an automatic inventory of items to be checked on hosts.

%package agent
Summary:	The check-mk's Agent
Requires:	xinetd
Group:		Applications/Internet

%description agent
This package contains the check-mk's agent. Install the following
agent on all the machines you plan to monitor with check-mk.

%package docs
Summary:	The check-mk's documentation
Group:		Applications/Internet
BuildArch:	noarch
AutoReq:	0
%if 0%{?rhel}
AutoProv:	0
%endif

%description docs
This package contains the check-mk's documentation files.

%package livestatus
Summary:	The check-mk's Livestatus
Group:		Applications/Internet
Requires:	check-mk
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description livestatus
This package contains livestatus, the check-mk's plugin	for
accessing the relevant Nagios files being responsible of
listing	the hosts and services status.

%package multisite
Summary:	The check-mk's Multisite
Group:		Applications/Internet
BuildArch:	noarch
Requires:	%{name} = %{version}-%{release}

%description multisite
This package contains the check-mk's web interface aka WATO.

%prep
%setup -q -n check_mk-%{version}
tar xf agents.tar.gz
tar xf web.tar.gz && rm -f web.tar.gz
%patch0 -p0
tar zcf web.tar.gz htdocs plugins

%build
rm -f waitmax
make waitmax

%install

# Agent's installation

install -d -m 755 %{buildroot}%{_sysconfdir}/xinetd.d
install -m 644 xinetd.conf %{buildroot}%{_sysconfdir}/xinetd.d/check-mk-agent

install -d -m 755 %{buildroot}%{_bindir}
install -m 755 check_mk_agent.linux %{buildroot}%{_bindir}/check_mk_agent

# mk-job installation
install -m 755 mk-job %{buildroot}%{_bindir}/mk-job

# Waitmax's binary
install -m 755 waitmax %{buildroot}%{_bindir}/waitmax

install -d -m 755 %{buildroot}%{_datadir}/check-mk-agent
install -d -m 755 %{buildroot}%{_datadir}/check-mk-agent/plugins
install -d -m 755 %{buildroot}%{_datadir}/check-mk-agent/local
install -m 644 plugins/mk_logwatch %{buildroot}%{_datadir}/check-mk-agent/plugins
# The j4p_performance plugin has been deprecated.
# install -m 644 plugins/j4p_performance %{buildroot}%{_datadir}/check-mk-agent/plugins
install -m 644 plugins/mk_oracle %{buildroot}%{_datadir}/check-mk-agent/plugins
install -m 644 plugins/sylo %{buildroot}%{_datadir}/check-mk-agent/plugins

install -d -m 755 %{buildroot}%{_sysconfdir}/check-mk-agent
install -m 644 logwatch.cfg %{buildroot}%{_sysconfdir}/check-mk-agent

perl -pi \
    -e 's|MK_LIBDIR="/usr/lib/check_mk_agent"|MK_LIBDIR="%{_datadir}/check-mk-agent"|;' \
    -e 's|MK_CONFDIR="/etc/check_mk"|MK_CONFDIR="%{_sysconfdir}/check-mk-agent"|;' \
    %{buildroot}%{_bindir}/check_mk_agent

# Server, livestatus and other modules installation

DESTDIR=%{buildroot} ./setup.sh --yes

# Some needed tweaks to modify setup.sh's defaults.

# /etc/apache2/conf.d --> /etc/httpd/conf.d
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d/
mv %{buildroot}%{_sysconfdir}/apache2/conf.d/zzz_check_mk.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/zzz_check_mk.conf
rm -rf %{buildroot}%{_sysconfdir}/apache2/

# Install the First-Installation.txt file
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/check_mk

# Make sure all the scripts into /usr/share/check_mk/* and /usr/share/check-mk-agent/* are executable.
for file in %{buildroot}%{_datadir}/check_mk/checks/* ; do
   chmod -R a+x $file
done

for file in %{buildroot}%{_datadir}/check-mk-agent/plugins/* ; do
   chmod a+x $file
done

# Fix a few more permissions
chmod a+x %{buildroot}%{_datadir}/check_mk/agents/hpux/hpux_statgrab
chmod a+x %{buildroot}%{_datadir}/check_mk/agents/hpux/hpux_lunstats
chmod a+x %{buildroot}%{_datadir}/check_mk/agents/plugins/db2_mem.sh
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/snmp.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/packaging.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/agent_simulator.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/notify.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/automation.py
chmod a+x %{buildroot}%{_datadir}/check_mk/notifications/debug
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/check_mk_base.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/prediction.py
chmod a+x %{buildroot}%{_datadir}/check_mk/modules/localize.py

# Web app files are not intended to be run, remove the shebang
# TODO: ask upstream to do the same
for file in `find %{buildroot}%{_datadir}/check_mk/web -name '*.py'`; do
 sed -i '1{\@^#!/usr/bin/python@d}' $file
done

# Copy the check_mk_templates.cfg from the example file and remove the file installed
# on the /etc/nagios/objects directory.
mkdir -p %{buildroot}%{_sysconfdir}/nagios/conf.d/
cp -r %{buildroot}%{_datadir}/check_mk/check_mk_templates.cfg %{buildroot}%{_sysconfdir}/nagios/conf.d/check_mk_templates.cfg
rm -rf %{buildroot}%{_sysconfdir}/nagios/objects/check_mk_templates.cfg

# Fix the path for the Nagios plugins
sed -i 's|/usr/lib/nagios/plugins|%{_libdir}/nagios/plugins|' \
  %{buildroot}%{_sysconfdir}/nagios/conf.d/check_mk_templates.cfg

# Remove the auto-generated defaults file and replace it with a customized version
rm -rf %{buildroot}%{_datadir}/check_mk/modules/defaults
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/check_mk/modules/

# Do the same for defaults.py
rm -rf %{buildroot}%{_datadir}/check_mk/web/htdocs/defaults.py
install -m 644 %{SOURCE3} %{buildroot}%{_datadir}/check_mk/web/htdocs/

# Remove other operating systems agents, we definitely don't need them on this package.
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.aix
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.freebsd
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.hpux
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.macosx
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.netbsd
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.openbsd
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.openvms
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.solaris
# No need to ship the check_mk_agent for Linux given that's what we install by default.
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_agent.linux
rm -rf %{buildroot}%{_datadir}/check_mk/agents/check_mk_caching_agent.linux
rm -rf %{buildroot}%{_datadir}/check_mk/agents/solaris/
rm -rf %{buildroot}%{_datadir}/check_mk/agents/hpux/
rm -rf %{buildroot}%{_datadir}/check_mk/agents/sap/

# Remove deprecated agent plugins.
rm -rf %{buildroot}%{_datadir}/check_mk/agents/plugins/j4p_performance

# Remove Windows files.
rm -rf %{buildroot}%{_docdir}/check_mk/windows/
rm -rf %{buildroot}%{_datadir}/check_mk/agents/windows/

# Remove waitmax and its leftarounds from the wrong directory, the binary is being
# built and installed into the check-mk-agent's package already.
rm %{buildroot}%{_datadir}/check_mk/agents/waitmax
rm %{buildroot}%{_datadir}/check_mk/agents/waitmax.c
rm %{buildroot}%{_datadir}/check_mk/agents/Makefile

# Remove the packages and modbus directories.
rm -rf %{buildroot}%{_localstatedir}/lib/check_mk/packages/
rm -rf %{buildroot}%{_docdir}/check_mk/treasures/modbus/

# Make sure an /etc/check_mk/conf.d/wato directory is created for WATO to work properly
mkdir -p %{buildroot}%{_sysconfdir}/check_mk/conf.d/wato

# Make sure the /var/lib/check_mk_agent/job directory is created by the RPM itself 
# and assigned correct permissions.
mkdir -p %{buildroot}%{_localstatedir}/lib/check_mk_agent/job

# Remove mk-job from its old location
rm -f %{buildroot}%{_datadir}/check_mk/agents/mk-job

# Fix for 64-bit arches
%if %{_lib} == lib64

mkdir -p %{buildroot}%{_prefix}/lib64/check_mk
mv %{buildroot}%{_prefix}/lib/check_mk/livestatus.o %{buildroot}%{_prefix}/lib64/check_mk/
rmdir %{buildroot}%{_prefix}/lib/check_mk

%endif

%files
%{_bindir}/cmk
%{_bindir}/mkp
%{_bindir}/check_mk
%config(noreplace) %{_sysconfdir}/check_mk/main.mk
%config(noreplace) %{_sysconfdir}/check_mk/main.mk-1.2.4p5
%{_sysconfdir}/check_mk/First-Installation.txt
%{_sysconfdir}/check_mk/conf.d
%{_sysconfdir}/nagios/auth.serials
%{_datadir}/check_mk/modules
%{_datadir}/check_mk/checks
%{_datadir}/check_mk/pnp-templates
%{_datadir}/check_mk/notifications
%{_datadir}/check_mk/check_mk_templates.cfg
%config(noreplace) %{_sysconfdir}/httpd/conf.d/zzz_check_mk.conf
%config(noreplace) %{_sysconfdir}/nagios/conf.d/check_mk_templates.cfg
%attr(755, nagios, nagios) %{_localstatedir}/lib/check_mk/*
%doc COPYING ChangeLog AUTHORS

%files agent
%{_datadir}/check_mk/agents
%{_bindir}/check_mk_agent
%{_bindir}/waitmax
%{_bindir}/mk-job
%{_datadir}/check-mk-agent
%config(noreplace) %{_sysconfdir}/xinetd.d/check-mk-agent
%config(noreplace) %{_sysconfdir}/check-mk-agent
%attr(755, -, -) %{_localstatedir}/lib/check_mk_agent/job  
%doc COPYING

%files docs
%doc %{_docdir}/check_mk

%files multisite
%{_datadir}/check_mk/web
%config(noreplace) %{_sysconfdir}/check_mk/multisite.mk
%config(noreplace) %{_sysconfdir}/check_mk/multisite.mk-1.2.4p5
%{_sysconfdir}/check_mk/multisite.d
%attr(660, apache, nagios) %{_sysconfdir}/check_mk/conf.d/wato

%files livestatus
%{_bindir}/unixcat
%{_libdir}/check_mk

%changelog
* Tue Sep 30 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4p5-2
- Do not require any other shell than bash since that's the default
  shell for the Fedora / RHEL distributions.

* Wed Sep 17 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4p5-1
- New upstream release. Fixes CVEs:
  - CVE-2014-5338 
  - CVE-2014-5339
  - CVE-2014-5340 (BZ: #1132337, #1132339, #1132341)
- Stop shipping the j4p_performance plugin as it's deprecated. (BZ: #1133068)
- Turn Wato_Legacy_Eval as True as we want to prevent breakages
  between machines running different Python and/or check-mk releases.
  This is necessary after the 'ast' move from 'pickle' (that was
  generating a insecure API call), however the 'ast' module is still
  not available for RHEL / CentOS 5 machines. The patch is there to 
  avoid miscommunications between different distribution releases. More
  information is available at:
  http://mathias-kettner.com/check_mk_werks.php?werk_id=984.

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.4p2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.4p2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue May 27 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4p2-2
- Install the mk-job binary on /usr/bin.
- Make sure the proper permissions are given to /var/lib/check_mk_agent/job
  to prevent any hard or symlink to be created by a normal user and pointing
  to any file on the filesystem exposing it on the check-mk-agent output being
  run as root. Fixes BZ #1101669.

* Mon Apr 14 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4p2-1
- New upstream release.

* Wed Apr 02 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4p1-1
- New upstream release. Fixes the missing two CVEs that were still
  left unfixed on 1.2.4:
  - CVE-2014-2330
  - CVE-2014-2331

* Tue Mar 25 2014 Andrea Veri <averi@fedoraproject.org> - 1.2.4-1
- New upstream release. Fixes the following CVEs:
  - CVE-2014-2329
  - CVE-2014-2332

* Wed Oct 02 2013 Andrea Veri <averi@fedoraproject.org> - 1.2.2p2-2
- Make sure an /etc/check_mk/conf.d/wato directory is created for WATO
  to work properly. (BZ: #987863)
- Improve the packages description.

* Sat Aug 31 2013 Andrea Veri <averi@fedoraproject.org> - 1.2.2p2-1
- New upstream release.

* Thu Aug 29 2013 Andrea Veri <averi@fedoraproject.org> - 1.2.2-6
- Make sure the waitmax binary gets built. Also thanks to John Reddy
  for his initial work on this. (BZ: #982769)
- Add an if statement for RHEL and make sure auto provides are not set
  automatically. (BZ #985285)
- Requires set to mod_python on RHEL, no mod_wsgi migration yet on EPEL. (BZ: #987852)
- Fix the perl command that was doing the needed substitution on the 
  /usr/bin/check_mk_agent's configuration directories. Thanks Brainslug for the
  report. (BZ: #989793)
- In addition to a customized 'defaults' file, add a defaults.py accordingly. (BZ: #987859)

* Fri Aug 02 2013 Petr Pisar <ppisar@redhat.com> - 1.2.2-5
- Do not provide from a documentation

* Sun Apr 28 2013 Andrea Veri <averi@fedoraproject.org> 1.2.2-5
- Make sure the Nagios library path on the check_mk_templates.cfg file
  is correct on both x86_64 and i686 systems.

* Sat Apr 27 2013 Andrea Veri <averi@fedoraproject.org> 1.2.2-4
- Change check-mk-agent's binary name to check_mk_agent to match xinetd's file. (BZ: #956489)
- Remove other operating systems agents, we definitely don't need them on this package.
- Make sure that check_mk_templates gets shipped into /etc/nagios/conf.d. (BZ: #956492)
- Don't ship the auto-generated defaults file, but provide it with our customizations. This actually
  fixes BZ: #956496 since we modify the checkresults path to be the same as the one provided
  by Nagios itself, thus no need to create an additional directory.

* Fri Apr 12 2013 Dan Horák <dan[at]danny.cz> - 1.2.2-3
- fix for 64-bit arches

* Wed Apr 10 2013 Andrea Veri <averi@fedoraproject.org> 1.2.2-2
- Remove the extra % on the Requires field for multisite.

* Tue Apr 09 2013 Andrea Veri <averi@fedoraproject.org> 1.2.2-1
- New upstream release.
- Added a depends on Nagios.
- Start shipping the docs, multisite, livestatus packages.
- Make sure the check_mk_templates.cfg file gets installed on the relevant 
  Nagios directory.
- Add the missing licenses.
- Switch package name to check-mk.
- Livestatus build has been fixed, switch the build/install system to use
  upstream's setup.sh.
- Include an handy First-Installation.txt file with instructions about what
  steps you should follow right after installing the check-mk's package.

* Fri Apr 05 2013 Andrea Veri <averi@fedoraproject.org> 1.2.0p4-1
- First package release.
